#!/bin/bash

INSTALL_DIR=$(pwd)

echo "Instalacja pakietów"
   
apt-get -y install autoconf-archive automake g++ libtool libleptonica-dev pkg-config
apt-get -y install git
apt-get -y install poppler-utils
apt-get -y install libjpeg-dev libtiff-dev libpng-dev

echo "Instalacja pakietów LEPTONICA"

mkdir /usr/lib/leptonica
cd /usr/lib/leptonica
wget http://www.leptonica.org/source/leptonica-1.78.0.tar.gz
gunzip leptonica-1.78.0.tar.gz
tar -xf leptonica-1.70.0.tar
cd leptonica-1.78.0
./configure
make
make install

echo "Instalacja pakietów TESSERACT"

mkdir /usr/lib/tesseract
cd /usr/lib/tesseract
git clone https://github.com/tesseract-ocr/tesseract.git tesseract-ocr
cd tesseract-ocr/
./autogen.sh
./configure --disable-openmp
make
make install
ldconfig

echo "Pobieranie pakietów tessdata"

cd /usr/local/share/tessdata/
wget https://github.com/tesseract-ocr/tessdata_fast/raw/master/script/Latin.traineddata
wget https://github.com/tesseract-ocr/tessdata_fast/raw/master/pol.traineddata
wget https://github.com/tesseract-ocr/tessdata_fast/raw/master/eng.traineddata
wget https://github.com/tesseract-ocr/tessdata_fast/raw/master/osd.traineddata


echo "Instalacja pakietów dla BUFFOR OCR"

apt-get -y install rabbitmq-server
apt-get -y install supervisor
apt-get -y install python-opencv
apt-get -y install python-pip
pip install pika

apt-get -y install pdftk

echo "Kopiowanie plików konfiguracyjnych supervisor"

cp -p $INSTALL_DIR'/conf/etc/supervisor/conf.d/edokumenty-worker-ocr.conf' /etc/supervisor/conf.d/
cp -p $INSTALL_DIR'/conf/etc/supervisor/conf.d/edokumenty-worker-ocr-result.conf' /etc/supervisor/conf.d/
cp -p $INSTALL_DIR'/conf/etc/supervisor/conf.d/edokumenty-worker-emails.conf' /etc/supervisor/conf.d/

echo "Tworzenie folderów dla RabbitMQ"

cd /home/edokumenty
mkdir rabbitmq
mkdir rabbitmq/logs
mkdir rabbitmq/logs/ocr
mkdir rabbitmq/logs/ocr_result

echo "Kopiowanie plików konfiguracyjnych RabbitMQ"

cp -p $INSTALL_DIR'/lib/hrabbitmq/edokumenty.ini' /home/edokumenty/rabbitmq/
cp -p $INSTALL_DIR'/lib/hrabbitmq/ocr.py' /home/edokumenty/rabbitmq/
cp -p $INSTALL_DIR'/lib/hrabbitmq/ocr_result.py' /home/edokumenty/rabbitmq/
cp -p $INSTALL_DIR'/lib/hrabbitmq/sendmail.py' /home/edokumenty/rabbitmq/

echo "Restart workerów"
sleep 5
supervisorctl restart all
