#!/bin/bash
# Server installation script for 
# Ready_™ on Debian Stretch 9
#
# @version 1.4.2 for Debian Stretch Version
# @author: eDokumenty
#

INSTALL_DIR=$(pwd)

echo -ne "\033[01;32mCzy chcesz instalowac pakiety managerem apt-get? Zalecane y (y/n) \033[00m \n"
read APTYESNO
if [ "$APTYESNO" = "y" ]; then

echo "Dodanie repozytorium dla PostgreSQL 11"
wget --quiet -O - https://www.postgresql.org/media/keys/ACCC4CF8.asc | apt-key add -
echo "deb http://apt.postgresql.org/pub/repos/apt/ stretch"-pgdg main | tee  /etc/apt/sources.list.d/pgdg.list
sleep 2

echo "Dodanie repozytorium dla PHP 7.2"
apt install ca-certificates apt-transport-https 
wget -q https://packages.sury.org/php/apt.gpg -O- | apt-key add -
echo "deb https://packages.sury.org/php/ stretch main" |  tee /etc/apt/sources.list.d/php.list
sleep 2

echo "Odświeżenie repozytoriów"
apt-get update

# Base tools
apt-get -y install ssh
apt-get -y install mc
apt-get -y install nmap
apt-get -y install ngrep
apt-get -y install sed
apt-get -y install wget
apt-get -y install gzip
apt-get -y install adduser
apt-get -y install bzip2
apt-get -y install unzip
apt-get -y install rsync
apt-get -y install less
apt-get -y install rdate
apt-get -y install vim

# System tools
apt-get -y install sudo
apt-get -y install cron
apt-get -y install iproute
apt-get -y install tcpdump
apt-get -y install ntp 
apt-get -y install htop
apt-get -y install iotop

# Additional tools
apt-get -y install apt-show-versions
apt-get -y install gcc
apt-get -y install g++
apt-get -y install cpp
apt-get -y install make
apt-get -y install curl

# Backup tools
apt-get -y install hdparm
apt-get -y install mt-st

# Processing tools
apt-get -y install imagemagick
apt-get -y install html2ps
apt-get -y install latex2rtf
apt-get -y install antiword
apt-get -y install gnuhtml2latex
apt-get -y install tesseract-ocr
apt-get -y install tesseract-ocr-pol

# Services Apache, PHP, PostgreSQL11
apt-get -y install postgresql-11
apt-get -y install apache2
apt-get -y install php7.2-fpm 
apt-get -y install php7.2-cli 
apt-get -y install php7.2-common 
apt-get -y install php7.2-curl 
apt-get -y install php7.2-mbstring 
apt-get -y install php7.2-mysql 
apt-get -y install php7.2-xml 
apt-get -y install php7.2-gd 
apt-get -y install php7.2-pgsql 
apt-get -y install php7.2-bcmath 
apt-get -y install php7.2-sqlite3 
apt-get -y install php7.2-imap 
apt-get -y install php7.2-xsl 
apt-get -y install php7.2-ldap 
apt-get -y install php7.2-odbc 
apt-get -y install php7.2-json 
apt-get -y install php7.2-sybase 
apt-get -y install php7.2-readline 
apt-get -y install php7.2-soap
apt-get -y install php7.2-zip

apt-get -y install apache2 libapache2-mod-fcgid

apt-get -y install redis-server
apt-get -y install php7.2-redis

apt-get -y install subversion
apt-get -y install openssl
apt-get -y install ssl-cert

apt-get -y install abiword

fi



# Instalacja pgbouncer + config
echo -ne "\033[01;32mCzy zainstalowac Pgbouncer? (y/n) \033[00m \n"
read PGBOUNCER
if [ "$PGBOUNCER" = "y" ]; then
    apt-get install pgbouncer
fi


echo "Zakladanie kont i konfiguracja grup dla użytkownika edokumenty"
# konta i grupy systemowe
adduser --ingroup users edokumenty 
groupadd edokumenty
adduser edokumenty edokumenty
adduser www-data edokumenty

echo "Zakladanie kont i konfiguracja grup dla użytkownika test"
# konta i grupy systemowe
adduser --ingroup users test 

echo "Aktywacja modulow Apache"
for module in ssl rewrite userdir vhost_alias actions fcgid alias proxy_fcgi headers
do 
    a2enmod $module;
done

#enable ssl
a2ensite default-ssl


# Instalacja pgbouncer + config
echo -ne "\033[01;32mCzy wykonać kopię plików konfiguracyjnych (y/n) \033[00m \n"
read BACKUPCONF
if [ "$BACKUPCONF" = "y" ]; then
    ./bin/backup_conf_client.sh
fi

# Modyfikacje plików konfiguracyjnych
echo -ne "\033[01;32mCzy modyfikowac pliki konfiguracyjne (zalecane y)? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then
echo "Modyfikacja plików konfiguracyjnych Apache"
	# Zmiana konfiguracji hostow Apache
    rm -f /etc/apache2/sites-available/*    
    cp -p $INSTALL_DIR'/conf/etc/apache2/sites-available/000-default.conf' /etc/apache2/sites-available/
    cp -p $INSTALL_DIR'/conf/etc/apache2/sites-available/default-ssl.conf' /etc/apache2/sites-available/
    cp -p $INSTALL_DIR'/conf/etc/apache2/apache2.conf' /etc/apache2/
	cp -p $INSTALL_DIR'/conf/etc/apache2/conf-available/security.conf' /etc/apache2/conf-available/
	
echo "Kopiowanie certyfiaktu dla localhost"
   # Kopiowanie testowego certyfiaktu dla SSL
    cp -p $INSTALL_DIR'/conf/etc/ssl/edokumenty.pem' /etc/ssl/certs/
    cp -p $INSTALL_DIR'/conf/etc/ssl/edokumenty.key' /etc/ssl/certs/

echo "Modyfikacja plików konfiguracyjnych PHP"	
    # Konfiguracja PHP/FPM
    cp -p $INSTALL_DIR'/conf/etc/php/7.2/cli/php.ini' /etc/php/7.2/cli/
	cp -p $INSTALL_DIR'/conf/etc/php/7.2/fpm/php.ini' /etc/php/7.2/fpm/
	cp -p $INSTALL_DIR'/conf/etc/php/7.2/fpm/pool.d/www.conf' /etc/php/7.2/fpm/pool.d/
	cp -p $INSTALL_DIR'/conf/etc/php/7.2/mods-available/bsedt.ini' /etc/php/7.2/mods-available/

echo "Modyfikacja plików konfiguracyjnych Redis"	
	#Konfiguracja php-redis
    cp -p $INSTALL_DIR'/conf/etc/redis/redis.conf' /etc/redis/

echo "Modyfikacja plików konfiguracyjnych pgbouncer"
	#Konfiguracja pgbouncer
    cp -p $INSTALL_DIR'/conf/etc/pgbouncer/pgbouncer.ini' /etc/pgbouncer
    cp -p $INSTALL_DIR'/conf/etc/pgbouncer/userlist.txt' /etc/pgbouncer
	
echo "Modyfikacja plików PostgreSQL - pg_hba.conf"
	cp -p $INSTALL_DIR'/conf/etc/postgresql/11/main/pg_hba.conf' /etc/postgresql/11/main

echo "Tworzenie symlinkow dla pakietu bsedt"	
	# Tworzenie linku symbolicznego do modulu bsedt
	ln -s /etc/php/7.2/mods-available/bsedt.ini /etc/php/7.2/cli/conf.d/bsedt.ini
	ln -s /etc/php/7.2/mods-available/bsedt.ini /etc/php/7.2/fpm/conf.d/bsedt.ini
 
echo "Wyłączenie opcache" 
	#Modyfikacja OPCACHE
	vim -c '%s/zend_extension=opcache.so/;zend_extension=opcache.so/' -c 'wq' /etc/php/7.2/mods-available/opcache.ini
   
    touch /var/log/php_error.log
    chown www-data:www-data /var/log/php_error.log

fi


echo "Utworzenie public_html i pozostałych podkatalogów. Nadanie uprawenień do odczytu i zapisu"
./bin/create_edok_dirs.sh

echo "Dodanie ramdisk w fstab dla backproc"
./bin/fstab.sh

# Instalacja IONCuber Loader
echo -ne "\033[01;32mCzy chcesz instalowac modul IONCube Loader dla PHP 7.2? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then
    echo "Instalacja IONCube Loader"
    cp   $INSTALL_DIR'/conf/usr/lib/php/ioncube_loader_lin_7.2.so' /usr/lib/php/
fi


echo "Instalacja modulu bsedt - tłumaczenia"
	cp   $INSTALL_DIR'/conf/usr/lib/php/20170718/bsedt.so' /usr/lib/php/20170718/


# Tworzenie użytkowników bazy danych (wszyscy z opcjami N)
echo "Tworzenie uzytkownika bazy danych - http (wszystkie opcje N)"
sudo -u postgres createuser --no-superuser --no-createdb --no-createrole http
echo "Tworzenie uzytkownika bazy danych - edokumenty (wszystkie opcje N)"
sudo -u postgres createuser --no-superuser --no-createdb --no-createrole edokumenty


# Tworzenie baz danych
echo "Tworzenie bazy edokumenty"
sudo -u postgres createdb -E UTF8 edokumenty -O edokumenty



echo "Konfiguracja domyslnego backupu - domyslne skrypty, ustawienia backapu i skrypty crona"
./bin/backup_dirs.sh

cd $INSTALL_DIR
cp -p $INSTALL_DIR'/lib/backup/backup_db' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_repos' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_files' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_publichtml' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/backup_repository' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/clear_edok_var' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/maildrop_clear' /etc/cron.daily/
cp -p $INSTALL_DIR'/lib/backup/update_test' /etc/cron.daily/

chmod 755 /etc/cron.daily/*

cp -p $INSTALL_DIR'/lib/backup/exclude.conf' /etc/backup
cp -p $INSTALL_DIR'/lib/backup/exclude_test.conf' /etc/backup



# Restart Apache i Postgres
echo "Restart Apache"
sleep 3
/etc/init.d/apache2 restart

echo "Restart FMP"
sleep 3
service php7.2-fpm restart


echo "Restart PostgreSQL"
sleep 3
/etc/init.d/postgresql restart


echo "Kopiowanie  FileIndexingTool"

cp $INSTALL_DIR'/lib/FileIndexingTool/Run.inc'  /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool/
cp $INSTALL_DIR'/lib/FileIndexingTool/FileIndex.inc'  /home/edokumenty/public_html/apps/edokumenty/scripts/FileIndexingTool/

echo "Dodanie wpisow do systemowego crona"
./bin/cron.sh

echo -ne "\033[01;32mInstalacja pakietów dodatkowych OCR? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then
    echo "Instalacja pakietów Tesseract"
    ./bin/ocr_packet.sh
fi

echo -ne "\033[01;32mInstalacja dla Generowanie podglądu plików do PDF? (y/n) \033[00m \n"
read CONFYESNO
if [ "$CONFYESNO" = "y" ]; then
    echo "Instalacja dla Generowanie podglądu plików do PDF"
    ./bin/libreoffice.sh
fi

echo "Koniec pracy instalatora"